import 'package:yuro_core/yuro_core.dart';

import 'yuro_instance.dart';

extension YuroInstanceExt on YuroInterface {
  T put<T>(T dependency, {String tag, bool permanent = false}) {
    return YuroInstance().put<T>(dependency, tag: tag, permanent: permanent);
  }

  Future<T> putAsync<T>(InstanceAsyncBuilder<T> builder, {String tag, bool permanent = false}) {
    return YuroInstance().putAsync<T>(builder, tag: tag, permanent: permanent);
  }

  void lazyPut<T>(InstanceBuilder<T> builder, {String tag, bool permanent = false}) {
    YuroInstance().lazyPut<T>(builder, tag: tag, permanent: permanent);
  }

  void create<T>(InstanceBuilder<T> builder, {String tag, bool permanent = true}) {
    return YuroInstance().create<T>(builder, tag: tag, permanent: permanent);
  }

  T find<T>({String tag}) {
    return YuroInstance().find<T>(tag: tag);
  }

  bool reset({bool clearFactory = true, bool clearRoute = true}) {
    return YuroInstance().reset(clearFactory: clearFactory, clearRoute: clearRoute);
  }

  Future<bool> delete<T>({String tag, bool force = false}) async {
    return YuroInstance().delete<T>(tag: tag, force: force);
  }

  bool isRegistered<T>({String tag}) {
    return YuroInstance().isRegistered<T>(tag: tag);
  }

  bool isPrepared<T>({String tag}) {
    return YuroInstance().isPrepared<T>(tag: tag);
  }
}
